"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _nodeContentRendererModule = _interopRequireDefault(require("./node-content-renderer.module.css"));

var _clsx4 = _interopRequireDefault(require("clsx"));

var _excluded = ["scaffoldBlockPxWidth", "toggleChildrenVisibility", "connectDragPreview", "connectDragSource", "isDragging", "canDrop", "canDrag", "node", "title", "draggedNode", "path", "treeIndex", "isSearchMatch", "isSearchFocus", "icons", "buttons", "className", "style", "didDrop", "lowerSiblingCounts", "listIndex", "swapFrom", "swapLength", "swapDepth", "treeId", "isOver", "parentNode", "rowDirection", "onClickNode", "selected"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function isDescendant(older, younger) {
  return !!older.children && typeof older.children !== 'function' && older.children.some(function (child) {
    return child === younger || isDescendant(child, younger);
  });
} // eslint-disable-next-line react/prefer-stateless-function


var FileThemeNodeContentRenderer = /*#__PURE__*/function (_Component) {
  _inherits(FileThemeNodeContentRenderer, _Component);

  var _super = _createSuper(FileThemeNodeContentRenderer);

  function FileThemeNodeContentRenderer() {
    _classCallCheck(this, FileThemeNodeContentRenderer);

    return _super.apply(this, arguments);
  }

  _createClass(FileThemeNodeContentRenderer, [{
    key: "render",
    value: function render() {
      var _clsx, _clsx2;

      var _this$props = this.props,
          scaffoldBlockPxWidth = _this$props.scaffoldBlockPxWidth,
          toggleChildrenVisibility = _this$props.toggleChildrenVisibility,
          connectDragPreview = _this$props.connectDragPreview,
          connectDragSource = _this$props.connectDragSource,
          isDragging = _this$props.isDragging,
          canDrop = _this$props.canDrop,
          canDrag = _this$props.canDrag,
          node = _this$props.node,
          title = _this$props.title,
          draggedNode = _this$props.draggedNode,
          path = _this$props.path,
          treeIndex = _this$props.treeIndex,
          isSearchMatch = _this$props.isSearchMatch,
          isSearchFocus = _this$props.isSearchFocus,
          icons = _this$props.icons,
          buttons = _this$props.buttons,
          className = _this$props.className,
          style = _this$props.style,
          didDrop = _this$props.didDrop,
          lowerSiblingCounts = _this$props.lowerSiblingCounts,
          listIndex = _this$props.listIndex,
          swapFrom = _this$props.swapFrom,
          swapLength = _this$props.swapLength,
          swapDepth = _this$props.swapDepth,
          treeId = _this$props.treeId,
          isOver = _this$props.isOver,
          parentNode = _this$props.parentNode,
          rowDirection = _this$props.rowDirection,
          onClickNode = _this$props.onClickNode,
          selected = _this$props.selected,
          otherProps = _objectWithoutProperties(_this$props, _excluded);

      var nodeTitle = title || node.title;

      if (typeof nodeTitle === 'function') {
        nodeTitle = nodeTitle({
          node: node,
          path: path,
          treeIndex: treeIndex
        });
      }

      var isDraggedDescendant = draggedNode && isDescendant(draggedNode, node);
      var isLandingPadActive = !didDrop && isDragging;
      var hasChildren = node.children && node.children.length > 0;
      var onClickrowContents = typeof onClickNode === 'function' ? onClickNode : function () {};

      var toggleExpanded = function toggleExpanded(event) {
        toggleChildrenVisibility({
          node: node,
          path: path,
          treeIndex: treeIndex
        });
        event.stopPropagation();
      }; // Construct the scaffold representing the structure of the tree


      var scaffold = [];
      lowerSiblingCounts.forEach(function (lowerSiblingCount, i) {
        scaffold.push( /*#__PURE__*/_react.default.createElement("div", {
          key: "pre_".concat(1 + i),
          style: {
            width: scaffoldBlockPxWidth
          },
          className: _nodeContentRendererModule.default.lineBlock
        }));

        if (treeIndex !== listIndex && i === swapDepth) {
          // This row has been shifted, and is at the depth of
          // the line pointing to the new destination
          var highlightLineClass = '';

          if (listIndex === swapFrom + swapLength - 1) {
            // This block is on the bottom (target) line
            // This block points at the target block (where the row will go when released)
            highlightLineClass = _nodeContentRendererModule.default.highlightBottomLeftCorner;
          } else if (treeIndex === swapFrom) {
            // This block is on the top (source) line
            highlightLineClass = _nodeContentRendererModule.default.highlightTopLeftCorner;
          } else {
            // This block is between the bottom and top
            highlightLineClass = _nodeContentRendererModule.default.highlightLineVertical;
          }

          scaffold.push( /*#__PURE__*/_react.default.createElement("div", {
            key: "highlight_".concat(1 + i),
            style: {
              width: scaffoldBlockPxWidth,
              left: scaffoldBlockPxWidth * i
            },
            className: "".concat(_nodeContentRendererModule.default.absoluteLineBlock, " ").concat(highlightLineClass)
          }));
        }
      });

      var nodeContent = /*#__PURE__*/_react.default.createElement("div", _extends({
        style: {
          height: '100%'
        }
      }, otherProps), /*#__PURE__*/_react.default.createElement("div", {
        className: (0, _clsx4.default)(_nodeContentRendererModule.default.rowWrapper, (_clsx = {}, _defineProperty(_clsx, _nodeContentRendererModule.default.rowWrapperDragDisabled, !canDrag), _defineProperty(_clsx, _nodeContentRendererModule.default.rowSelected, selected && !isLandingPadActive), _defineProperty(_clsx, _nodeContentRendererModule.default.rowWrapperLandingPadActive, isLandingPadActive), _clsx)),
        onClick: onClickrowContents
      }, connectDragPreview( /*#__PURE__*/_react.default.createElement("div", {
        style: {
          display: 'flex',
          height: '100%'
        }
      }, scaffold, /*#__PURE__*/_react.default.createElement("div", {
        className: (0, _clsx4.default)(_nodeContentRendererModule.default.row, (_clsx2 = {}, _defineProperty(_clsx2, _nodeContentRendererModule.default.rowLandingPad, isLandingPadActive), _defineProperty(_clsx2, _nodeContentRendererModule.default.rowCancelPad, isLandingPadActive && !canDrop), _defineProperty(_clsx2, _nodeContentRendererModule.default.rowSearchMatch, isSearchMatch), _defineProperty(_clsx2, _nodeContentRendererModule.default.rowSearchFocus, isSearchFocus), _defineProperty(_clsx2, className, className), _clsx2)),
        style: _objectSpread({
          opacity: isDraggedDescendant ? 0.5 : 1
        }, style)
      }, hasChildren && /*#__PURE__*/_react.default.createElement("div", {
        className: (0, _clsx4.default)(_nodeContentRendererModule.default.toolbarButton, _nodeContentRendererModule.default.arrowContainer),
        onClick: toggleExpanded
      }, /*#__PURE__*/_react.default.createElement("span", {
        className: (0, _clsx4.default)(_nodeContentRendererModule.default.arrow, node.expanded ? _nodeContentRendererModule.default.down : _nodeContentRendererModule.default.right)
      })), /*#__PURE__*/_react.default.createElement("div", {
        className: (0, _clsx4.default)(_nodeContentRendererModule.default.rowContents, _defineProperty({}, _nodeContentRendererModule.default.rowContentsDragDisabled, !canDrag))
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: _nodeContentRendererModule.default.rowToolbar
      }, icons.map(function (icon, index) {
        return /*#__PURE__*/_react.default.createElement("div", {
          key: index // eslint-disable-line react/no-array-index-key
          ,
          className: _nodeContentRendererModule.default.toolbarButton
        }, icon);
      })), /*#__PURE__*/_react.default.createElement("div", {
        className: _nodeContentRendererModule.default.rowLabel
      }, /*#__PURE__*/_react.default.createElement("span", {
        className: _nodeContentRendererModule.default.rowTitle
      }, nodeTitle)), /*#__PURE__*/_react.default.createElement("div", {
        className: _nodeContentRendererModule.default.rowToolbar
      }, buttons.map(function (btn, index) {
        return /*#__PURE__*/_react.default.createElement("div", {
          key: index // eslint-disable-line react/no-array-index-key
          ,
          className: _nodeContentRendererModule.default.toolbarButton
        }, btn);
      }))))))));

      return canDrag ? connectDragSource(nodeContent, {
        dropEffect: 'copy'
      }) : nodeContent;
    }
  }]);

  return FileThemeNodeContentRenderer;
}(_react.Component);

FileThemeNodeContentRenderer.defaultProps = {
  buttons: [],
  canDrag: false,
  canDrop: false,
  className: '',
  draggedNode: null,
  icons: [],
  isSearchFocus: false,
  isSearchMatch: false,
  parentNode: null,
  style: {},
  swapDepth: null,
  swapFrom: null,
  swapLength: null,
  title: null,
  toggleChildrenVisibility: null,
  onClickNode: null
};
FileThemeNodeContentRenderer.propTypes = {
  buttons: _propTypes.default.arrayOf(_propTypes.default.node),
  canDrag: _propTypes.default.bool,
  className: _propTypes.default.string,
  icons: _propTypes.default.arrayOf(_propTypes.default.node),
  isSearchFocus: _propTypes.default.bool,
  isSearchMatch: _propTypes.default.bool,
  listIndex: _propTypes.default.number.isRequired,
  lowerSiblingCounts: _propTypes.default.arrayOf(_propTypes.default.number).isRequired,
  node: _propTypes.default.shape({
    expanded: _propTypes.default.bool,
    title: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func]),
    children: _propTypes.default.instanceOf(Array)
  }).isRequired,
  path: _propTypes.default.arrayOf(_propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number])).isRequired,
  scaffoldBlockPxWidth: _propTypes.default.number.isRequired,
  style: _propTypes.default.shape({}),
  swapDepth: _propTypes.default.number,
  swapFrom: _propTypes.default.number,
  swapLength: _propTypes.default.number,
  title: _propTypes.default.oneOfType([_propTypes.default.func, _propTypes.default.node]),
  toggleChildrenVisibility: _propTypes.default.func,
  treeIndex: _propTypes.default.number.isRequired,
  treeId: _propTypes.default.string.isRequired,
  rowDirection: _propTypes.default.string.isRequired,
  // Drag and drop API functions
  // Drag source
  connectDragPreview: _propTypes.default.func.isRequired,
  connectDragSource: _propTypes.default.func.isRequired,
  didDrop: _propTypes.default.bool.isRequired,
  draggedNode: _propTypes.default.shape({}),
  isDragging: _propTypes.default.bool.isRequired,
  parentNode: _propTypes.default.shape({}),
  // Needed for dndManager
  // Drop target
  canDrop: _propTypes.default.bool,
  isOver: _propTypes.default.bool.isRequired,
  // custom
  onClickNode: _propTypes.default.func,
  selected: _propTypes.default.bool
};
var _default = FileThemeNodeContentRenderer;
exports.default = _default;