"use strict";

var _genericUtils = require("./generic-utils");

describe('slideRows', function () {
  it('should handle empty slide', function () {
    expect((0, _genericUtils.slideRows)([0, 1, 2], 1, 2, 0)).toEqual([0, 1, 2]);
    expect((0, _genericUtils.slideRows)([0, 1, 2], 1, 0, 0)).toEqual([0, 1, 2]);
    expect((0, _genericUtils.slideRows)([0, 1, 2], 1, 1, 0)).toEqual([0, 1, 2]);
  });
  it('should handle single slides', function () {
    expect((0, _genericUtils.slideRows)([0, 1, 2], 1, 1, 1)).toEqual([0, 1, 2]);
    expect((0, _genericUtils.slideRows)([0, 1, 2], 1, 2, 1)).toEqual([0, 2, 1]);
    expect((0, _genericUtils.slideRows)([0, 1, 2], 1, 0, 1)).toEqual([1, 0, 2]);
    expect((0, _genericUtils.slideRows)([0, 1, 2], 0, 2, 1)).toEqual([1, 2, 0]);
  });
  it('should handle multi slides', function () {
    expect((0, _genericUtils.slideRows)([0, 1, 2], 1, 0, 2)).toEqual([1, 2, 0]);
    expect((0, _genericUtils.slideRows)([0, 1, 2, 3], 0, 2, 2)).toEqual([2, 3, 0, 1]);
    expect((0, _genericUtils.slideRows)([0, 1, 2, 3], 3, 0, 2)).toEqual([3, 0, 1, 2]);
  });
});